Index: /code/branches/weapons/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- /code/branches/weapons/src/orxonox/OrxonoxPrereqs.h	(revision 2919)
+++ /code/branches/weapons/src/orxonox/OrxonoxPrereqs.h	(revision 2920)
@@ -165,5 +165,5 @@
     class ReplenishingMunition;
     class Munition;
-    class LaserGunMunition;
+    class LaserMunition;
     class FusionMunition;
 
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/CMakeLists.txt
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/CMakeLists.txt	(revision 2919)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/CMakeLists.txt	(revision 2920)
@@ -1,5 +1,5 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
   ReplenishingMunition.cc
-  LaserGunMunition.cc
+  LaserMunition.cc
   FusionMunition.cc
 )
Index: de/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.cc	(revision 2919)
+++ 	(revision )
@@ -1,55 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Martin Polak
- *   Co-authors:
- *      ...
- *
- */
-
-#include "OrxonoxStableHeaders.h"
-#include "LaserGunMunition.h"
-
-#include "core/CoreIncludes.h"
-
-namespace orxonox
-{
-    CreateFactory(LaserGunMunition);
-
-    LaserGunMunition::LaserGunMunition(BaseObject* creator) : ReplenishingMunition(creator)
-    {
-        RegisterObject(LaserGunMunition);
-
-        this->maxMunitionPerMagazine_ = 20;
-        this->maxMagazines_ = 1;
-        this->magazines_ = 1;
-
-        this->bUseSeparateMagazines_ = false;
-        this->bStackMunition_ = true;
-
-        this->bAllowMunitionRefilling_ = true;
-        this->bAllowMultiMunitionRemovementUnderflow_ = true;
-
-        this->replenishIntervall_ = 0.5f;
-        this->replenishMunitionAmount_ = 1;
-    }
-}
Index: de/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.h	(revision 2919)
+++ 	(revision )
@@ -1,45 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Martin Polak
- *   Co-authors:
- *      ...
- *
- */
-
-#ifndef _LaserGunMunition_H__
-#define _LaserGunMunition_H__
-
-#include "OrxonoxPrereqs.h"
-#include "ReplenishingMunition.h"
-
-namespace orxonox
-{
-    class _OrxonoxExport LaserGunMunition : public ReplenishingMunition
-    {
-        public:
-            LaserGunMunition(BaseObject* creator);
-            virtual ~LaserGunMunition() {}
-    };
-}
-
-#endif /* _LaserGunMunition_H__ */
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserMunition.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserMunition.cc	(revision 2920)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserMunition.cc	(revision 2920)
@@ -0,0 +1,55 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Martin Polak
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "LaserMunition.h"
+
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    CreateFactory(LaserMunition);
+
+    LaserMunition::LaserMunition(BaseObject* creator) : ReplenishingMunition(creator)
+    {
+        RegisterObject(LaserMunition);
+
+        this->maxMunitionPerMagazine_ = 20;
+        this->maxMagazines_ = 1;
+        this->magazines_ = 1;
+
+        this->bUseSeparateMagazines_ = false;
+        this->bStackMunition_ = true;
+
+        this->bAllowMunitionRefilling_ = true;
+        this->bAllowMultiMunitionRemovementUnderflow_ = true;
+
+        this->replenishIntervall_ = 0.5f;
+        this->replenishMunitionAmount_ = 1;
+    }
+}
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserMunition.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserMunition.h	(revision 2920)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserMunition.h	(revision 2920)
@@ -0,0 +1,45 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Martin Polak
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _LaserMunition_H__
+#define _LaserMunition_H__
+
+#include "OrxonoxPrereqs.h"
+#include "ReplenishingMunition.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport LaserMunition : public ReplenishingMunition
+    {
+        public:
+            LaserMunition(BaseObject* creator);
+            virtual ~LaserMunition() {}
+    };
+}
+
+#endif /* _LaserMunition_H__ */
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/weapons/LaserFire.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/weapons/LaserFire.cc	(revision 2919)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/weapons/LaserFire.cc	(revision 2920)
@@ -49,5 +49,5 @@
         this->speed_ = 1250;
 
-        this->setMunitionName("LaserGunMunition");
+        this->setMunitionName("LaserMunition");
     }
 